VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TagAttributes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"TagAttribute"
Attribute VB_Ext_KEY = "Member0" ,"TagAttribute"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private varReadOnly As Boolean

Private colAttributes As Collection
Private varItemCount As Long

Friend Property Get ReadOnly() As Boolean
ReadOnly = varReadOnly
End Property

Private Function NameIndex(ByVal Name As String) As Long
Dim I As Long
On Error Resume Next
I = colAttributes.Item(UCase$(Name)).Order
If Err.Number > 0 Then I = 0
On Error GoTo 0
End Function

Public Function Exist(Optional ByVal Name As String, Optional ByVal Index As Long) As Boolean
If Len(Name) = 0 Then
  Exist = ((Index > 1) And (Index <= varItemCount))
Else
  Exist = (NameIndex(Name) > 0)
End If
End Function

Public Function Add(ByVal Name As String, Optional ByVal Value As String, Optional ByVal Standalone As Boolean = False, Optional ByVal InsertBefore As Long) As TagAttribute
Dim objNewAttribute As TagAttribute, I As Long
I = NameIndex(Name)
If I > 0 Then
  Set Add = colAttributes.Item(I)
  Exit Function
End If
Set objNewAttribute = New TagAttribute
If InsertBefore = 0 Or InsertBefore > varItemCount Then InsertBefore = varItemCount + 1
objNewAttribute.SetName Name
objNewAttribute.SetValue Value
objNewAttribute.SetStandalone Standalone
objNewAttribute.SetReadOnly varReadOnly
If InsertBefore = varItemCount + 1 Then
  colAttributes.Add Key:=UCase$(Name), Item:=objNewAttribute
Else
  colAttributes.Add Key:=UCase$(Name), Item:=objNewAttribute, Before:=InsertBefore
End If
Set Add = objNewAttribute
Set objNewAttribute = Nothing
varItemCount = varItemCount + 1
For I = InsertBefore To varItemCount
  Set objNewAttribute = colAttributes.Item(I)
  objNewAttribute.SetOrder I
  Set objNewAttribute = Nothing
Next I
End Function

Public Property Get Item(Optional ByVal Name As String, Optional ByVal Index As Long) As TagAttribute
Attribute Item.VB_UserMemId = 0
If Len(Name) > 0 Then Index = NameIndex(Name)
If ((Index > 0) And (Index <= varItemCount)) Then Set Item = colAttributes.Item(Index)
End Property

Public Property Get Count() As Long
Count = varItemCount
End Property

Public Sub Remove(Optional ByVal Name As String, Optional ByVal Index As Long)
Dim objAttribute As TagAttribute, I As Long
If Len(Name) > 0 Then Index = NameIndex(Name)
If Index < 1 Or Index > varItemCount Then Exit Sub
colAttributes.Remove Index
varItemCount = varItemCount - 1
For I = Index To varItemCount
  Set objAttribute = colAttributes.Item(I)
  objAttribute.SetOrder Index
  Set objAttribute = Nothing
Next I
End Sub

Public Sub Clear()
While colAttributes.Count > 0
  colAttributes.Remove 1
Wend
varItemCount = 0
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
Set NewEnum = colAttributes.[_NewEnum]
End Property

Private Sub Class_Initialize()
Print #1, "TagAttributes + :: " & ObjPtr(Me)
varReadOnly = True
Set colAttributes = New Collection
varItemCount = 0
End Sub

Private Sub Class_Terminate()
Set colAttributes = Nothing
Print #1, "TagAttributes - :: " & ObjPtr(Me)
End Sub

Friend Sub SetReadOnly(ByVal NewValue As Boolean)
Dim objAttribute As TagAttribute, I As Long
varReadOnly = NewValue
For I = 1 To varItemCount
  Set objAttribute = colAttributes.Item(I)
  objAttribute.SetOrder I
  Set objAttribute = Nothing
Next I
End Sub
