VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Tags"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"Tag"
Attribute VB_Ext_KEY = "Member0" ,"Tag"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private varReadOnly As Boolean
Private varFlatMode As Boolean
Private varServiceMode As Boolean
Private varFilter As String

Private objDocument As Document
Private objHTMLStore As TextStore
Private objParent As Tag

Private colTags As Collection
Private varTagsCount As Long

Private Function ActualIndex(ByVal Index As Long, Optional ByVal Filter As String) As Long
Dim C As Long, I As Long, objTag As Tag
If Index = 0 Or Index > varTagsCount Then Exit Function
If Len(Filter) = 0 Then Filter = varFilter
For Each objTag In colTags
  C = C + 1
  If Len(Filter) = 0 Then
    I = I + 1
  Else
    If objTag.Name = Filter Then I = I + 1
  End If
  If I = Index Then Exit For
Next objTag
Set objTag = Nothing
If Index < 0 Then
  ActualIndex = I
Else
  ActualIndex = C
End If
End Function

Friend Sub SetFilter(Optional ByVal Filter As String)
varFilter = UCase$(Filter)
End Sub

Friend Property Get ReadOnly() As Boolean
ReadOnly = varReadOnly
End Property

Friend Sub SetReadOnly(ByVal NewValue As Boolean)
varReadOnly = NewValue
End Sub

Friend Property Get FlatMode() As Boolean
FlatMode = varFlatMode
End Property

Friend Sub SetFlatMode(ByVal NewValue As Boolean)
varFlatMode = NewValue
End Sub

Public Property Get ParentTag() As Tag
Set ParentTag = objParent
End Property

Public Property Get Document() As Document
Set Document = objDocument
End Property

Friend Function ChildIndex(Child As Tag) As Long
Dim C As Long, I As Long, objTag As Tag
If Not (Child Is Nothing) Then
  If Len(varFilter) > 0 Then
    If Child.Name <> varFilter Then
      ChildIndex = -1
      Exit Function
    End If
  End If
End If
For Each objTag In colTags
  C = C + 1
  If Len(varFilter) = 0 Then
    I = I + 1
    If objTag Is Child Then
      ChildIndex = I
      Exit For
    End If
  Else
    If objTag.Name = varFilter Then
      I = I + 1
      If objTag Is Child Then
        ChildIndex = I
        Exit For
      End If
    End If
  End If
Next objTag
Set objTag = Nothing
End Function

Public Function Add(ByVal Name As String, Optional ByVal Disabled As Boolean = False, Optional ByVal InsertPos As Long, Optional ByVal InsertAfter As Boolean) As Tag
If Len(Name) = 0 Then Exit Function
Dim objNewTag As Tag
Set objNewTag = New Tag
objNewTag.Create Me, objDocument, varFlatMode, objHTMLStore
objNewTag.SetServiceMode varServiceMode
objNewTag.SetReadOnly varReadOnly
objNewTag.SetName Name
objNewTag.SetDisabled Disabled
If InsertPos > 0 And InsertPos <= varTagsCount Then
  If InsertAfter Then
    colTags.Add Item:=objNewTag, After:=InsertPos
  Else
    colTags.Add Item:=objNewTag, Before:=InsertPos
  End If
Else
  colTags.Add Item:=objNewTag
End If
varTagsCount = varTagsCount + 1
Set Add = objNewTag
Set objNewTag = Nothing
End Function

Public Property Get Item(ByVal Index As Long) As Tag
Attribute Item.VB_UserMemId = 0
Index = ActualIndex(Index)
If Index = 0 Then Exit Property
Set Item = colTags.Item(Index)
End Property

Public Property Get Count(Optional ByVal IncludeChilds As Boolean) As Long
Dim res As Long, objTag As Tag
res = ActualIndex(-1)
If IncludeChilds Then
  For Each objTag In colTags
    res = res + objTag.Childs.Count(IncludeChilds)
  Next objTag
End If
Count = res
End Property

Public Sub Remove(ByVal Index As Long)
Dim objTag As Tag
Index = ActualIndex(Index)
If Index = 0 Then Exit Sub
Set objTag = colTags.Item(Index)
objTag.Dispose
Set objTag = Nothing
colTags.Remove Index
varTagsCount = varTagsCount - 1
End Sub

Public Sub Clear()
While varTagsCount > 0
  Remove 1
Wend
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
Set NewEnum = colTags.[_NewEnum]
End Property

Friend Sub RemoveMe(Child As Tag)
Dim I As Long
I = ChildIndex(Child)
If I > 0 Then Remove I
End Sub

Friend Sub Create(Optional Parent As Tag, Optional Document As Document, Optional HTMLStore As TextStore)
Set objParent = Parent
Set objDocument = Document
Set objHTMLStore = HTMLStore
End Sub

Friend Sub Dispose()
SetFilter
Clear
Set objParent = Nothing
Set objDocument = Nothing
Set objHTMLStore = Nothing
End Sub

Private Sub Class_Initialize()
Print #1, "Tags + :: " & ObjPtr(Me)
Set colTags = New Collection
varTagsCount = 0
End Sub

Private Sub Class_Terminate()
Set colTags = Nothing
Print #1, "Tags - :: " & ObjPtr(Me)
End Sub
